import pickle

import numpy as np

preds = pickle.load(open('ego_2048x512.pkl', 'rb'))
datas = pickle.load(open('data_nocam.pkl', 'rb'))


for curr_pred, data in zip(preds, datas[::3]):
    results = []
    curr_pred = np.squeeze(curr_pred, 0)
    curr_pred = np.concatenate([
        np.zeros((1, 3)),
        curr_pred
    ], axis=0)

    # 1 + 40
    L = curr_pred.shape[0]
    heading = curr_pred[:, -1]

    # 1 * 3 + 41 * 3
    xyz = data['ego']['position_xyz'][None] + np.concatenate([
        # x,y
        curr_pred[:, :2],
        # z
        np.zeros((L, 1))
    ], axis=1)
    # todo how to use quaternion

    roll_pitch_yaw = np.concatenate([
        # roll, pitch
        np.zeros((L, 1)),
        np.zeros((L, 1)),
        # yaw
        heading[:, None] + data['ego']['pose_xyzw_quaternion'][-1]
    ], axis=1)

    results.append({
        'timestamp': data['ego']['metadata']['gps_timestamp'],
        'xyz': xyz,
        'roll_pitch_yaw': roll_pitch_yaw
    })
    # csv ...